function [e, g] = persistence_objective(surface, basis, coeffs)
    f = basis*coeffs;
    [birth_ids, death_ids] = paired_mesh_persistence(surface, f);
    
    B = [birth_ids, death_ids];
    [~,order] = sort(f(B(:,1))-f(B(:,2)),'descend');
    B = B(order,:);
    birth_ids = B(:,1);
    death_ids = B(:,2);

    e = 1/2*sum((f(birth_ids(2:end)) - f(death_ids(2:end))).^2);
    
    D = basis(birth_ids(2:end),:)-basis(death_ids(2:end),:);
    e2 = 1/2*coeffs'*(D'*D)*coeffs;
    assert(norm(e - e2)<1e-7);
    g = (D'*D)*coeffs;
end